

Application create: #ToolCluster with:
        (#( CommonWidgets MaterialCluster)
            collect: [:each | Smalltalk at: each ifAbsent: [
                self error: 'Not all of the prerequisites are loaded']])!

ToolCluster becomeDefault!
Application subclass: #ToolCluster
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
IdClause subclass: #FPartIdClause
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
IdClause subclass: #IPartIdClause
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
IdClause subclass: #MaterialIdClause
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
NameClause subclass: #ToolnameClause
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
Material subclass: #FPart
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
FPart subclass: #CompositeFp
    instanceVariableNames: 'subFp subFpCol '
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
CompositeFp subclass: #SimpleBrowserFp
    instanceVariableNames: 'listerFp editorFp '
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
FPart subclass: #ListerFp
    instanceVariableNames: 'indexable selectedItemCol selectedItem selectedItemIndex multipleSelect '
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
FPart subclass: #SimpleEditorFp
    instanceVariableNames: 'editable '
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
FPart subclass: #SimpleViewerFp
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
Material subclass: #IPart
    instanceVariableNames: 'fPart '
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
IPart subclass: #CompositeIp
    instanceVariableNames: 'subIp subIpCol '
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
CompositeIp subclass: #SimpleBrowserIp
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
IPart subclass: #ListerIp
    instanceVariableNames: 'itemList '
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
IPart subclass: #SimpleEditorIp
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
IPart subclass: #SimpleViewerIp
    instanceVariableNames: 'itemList '
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
Material subclass: #Tool
    instanceVariableNames: 'toolName material uPart iPart fPart shellWidget mainWidget '
    classVariableNames: ''
    poolDictionaries: 'CwConstants '!

ToolCluster becomeDefault!
Tool subclass: #ComplexTool
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
ComplexTool subclass: #SimpleBrowser
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
Tool subclass: #Lister
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
Tool subclass: #SimpleEditor
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
Tool subclass: #SimpleViewer
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
Material subclass: #UPart
    instanceVariableNames: 'rootWidget iPart '
    classVariableNames: ''
    poolDictionaries: 'CwConstants '!

ToolCluster becomeDefault!
UPart subclass: #ListerUp
    instanceVariableNames: 'listWidget '
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
UPart subclass: #SimpleBrowserUp
    instanceVariableNames: 'form '
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
UPart subclass: #SimpleEditorUp
    instanceVariableNames: 'textWidget '
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!
UPart subclass: #SimpleViewerUp
    instanceVariableNames: 'textWidget '
    classVariableNames: ''
    poolDictionaries: ''!

ToolCluster becomeDefault!

!CompositeFp publicMethods !

addSubFp: anFPart

	self subFpCol add: anFPart.
	anFPart addDependent: self.
	subFp := anFPart.

	self changed: #cEvSubFpAdded.
	subFp := nil.!

createSubFps
	"do nothing"!

initialize
	super initialize.
	subFpCol := OrderedCollection new.
!

removeSubFp: anFPart

	self subFpCol remove: anFPart.
	subFp := anFPart.

	self changed: #cEvSubFpRemoved.
	subFp := nil.!

subFp
	^subFp!

subFpCol
	^subFpCol!

update: aSymbol from: anFPart
	super update: aSymbol from: anFPart.! !


!CompositeIp publicMethods !

addSubIp: anIPart

	self subIpCol add: anIPart.
	subIp := anIPart.

	self changed: #cEvSubIpAdded.
	subIp := nil.!

createSubIpFor: anFPart
	| anIPartClass |

	anIPartClass := IPart getClassByIdClause: ( FPartIdClause new: ( anFPart class symbol ) ).
	self addSubIp: ( anIPartClass new: anFPart ).!

initialize
	subIpCol := OrderedCollection new.!

removeSubIp: anIPart

	self subIpCol remove: anIPart.
	subIp := anIPart.

	self changed: #cEvSubIpRemoved.
	subIp := nil.!

subIp
	^subIp!

subIpCol
	^subIpCol!

update: aSymbol from: anFPart

	( aSymbol == #cEvSubFpAdded ) ifTrue: [
		^self createSubIpFor: ( anFPart subFp ) ].

	super update: aSymbol from: anFPart.! !


!FPart class publicMethods !

new
	^super new initialize! !


!FPart publicMethods !

initialize
	"do nothing"! !


!FPartIdClause class publicMethods !

isAbstract
	^false!

root
	^IPart! !


!FPartIdClause publicMethods !

adaptToClass: anIPartClass
	id := anIPartClass fPartClass symbol! !


!IPart class publicMethods !

fPartClass
	^FPart!

new: anFPart
	^super new initialize: anFPart! !


!IPart publicMethods !

fPart
	^fPart!

initialize
	"do nothing"!

initialize: anFPart

	self initialize.
	fPart := anFPart.
	anFPart addDependent: self.! !


!IPartIdClause publicMethods !

adaptToClass: anUPartClass
	id := anUPartClass iPartClass symbol! !


!Lister class publicMethods !

isAbstract
	^false!

materialClass
	^Indexable!

toolName
	^'lister tool'! !


!Lister publicMethods !

initialize

	super initialize.

	self initMainComponent: ListerUp iPart: ListerIp fPart: ListerFp.
!

material: aMaterial
	super material: aMaterial.
	self fPart indexable: aMaterial! !


!ListerFp publicMethods !

deselectItemIndex: index

	selectedItem := nil.
	selectedItemIndex := 0.
	selectedItemCol remove: ( self indexable at: index ).

	self changed: #cEvItemDeselected!

indexable
	^indexable!

indexable: anIndexable

	indexable := anIndexable.
	self changed: #cEvIndexableChanged.
!

initialize

	indexable := SortedCollection new.
	selectedItemCol := OrderedCollection new.

	self multipleSelect: false.!

isSelected: index

	^self selectedItemCol includes: ( self indexable at: index ).!

multipleSelect
	^multipleSelect!

multipleSelect: flag
	multipleSelect := flag.
	self changed: #cEvSelPolicyChanged!

selectedItem
	^selectedItem!

selectedItemCol
	^selectedItemCol!

selectedItemIndex
	^selectedItemIndex!

selectItemIndex: index

	selectedItem := ( self indexable at: index ).
	selectedItemIndex := index.

	self multipleSelect ifFalse: [
		self selectedItemCol removeAll: ( self selectedItemCol ) ].

	( self selectedItemCol ) add: selectedItem.

	self changed: #cEvItemSelected
! !


!ListerIp class publicMethods !

fPartClass
	^ListerFp! !


!ListerIp publicMethods !

deselectItemIndex: index
	self fPart deselectItemIndex: index!

isSelected: index
	^self fPart isSelected: index!

itemList
	^itemList!

itemListFromCol: aCol

	itemList := OrderedCollection new.

	aCol do: [ :item |
		itemList add: ( item listName ) ].

	self changed: #cEvItemListChanged.!

multipleSelect
	^self fPart multipleSelect!

selectItemIndex: index

	self fPart selectItemIndex: index!

update: aSymbol from: anObject

	aSymbol == #cEvIndexableChanged ifTrue: [
		^self updateIndexable ].

	aSymbol == #cEvItemSelected ifTrue: [
		^self changed: #cEvIndexableChanged ].

	super update: aSymbol from: anObject.!

updateIndexable

	self itemListFromCol: ( self fPart indexable ).

	self changed: #cEvIndexableChanged.! !


!ListerUp class publicMethods !

iPartClass
	^ListerIp! !


!ListerUp publicMethods !

browseSelect: widget clientData: clientData callData: callData
	"forget about widget and clientData - not used"

	( self iPart isSelected: ( callData itemPosition ) )
	ifTrue: [
		self iPart deselectItemIndex: ( callData itemPosition ) ]
	ifFalse: [
		self iPart selectItemIndex: ( callData itemPosition ) ]!

create

	listWidget := ( self rootWidget )
		createScrolledList: 'list'
		argBlock: [ :w | w
			selectionPolicy: XmBROWSESELECT;
			visibleItemCount: 8;
			width: 180;
			height: 240 ].

	listWidget addCallback: XmNbrowseSelectionCallback
		receiver: self
		selector: #browseSelect:clientData:callData:
		clientData: nil.

	listWidget addCallback: XmNmultipleSelectionCallback
		receiver: self
		selector: #multipleSelect:clientData:callData:
		clientData: nil.

	self manage.!

listWidget
	^listWidget!

listWidget: aListWidget
	listWidget := aListWidget!

manage
	self listWidget manageChild.!

multipleSelect: widget clientData: clientData callData: callData
	"forget about widget and clientData - not used"

	self browseSelect: widget clientData: clientData callData: callData.!

unmanage
	self listWidget unmanageChild.!

update: aSymbol from: anObject

	aSymbol == #cEvIndexableChanged ifTrue: [
		^self updateItemList ].

	aSymbol == #cEvSelPolicyChanged	ifTrue: [
		^self updateSelPolicy ].
		
	super update: aSymbol from: anObject.!

updateItemList

	self listWidget isNil ifFalse: [
		self listWidget items: ( self iPart itemList ) ]
!

updateSelPolicy

	self iPart multipleSelect
	ifTrue: [
		self listWidget selectionPolicy: XmMULTIPLESELECT ]
	ifFalse: [
		self listWidget selectionPolicy: XmBROWSESELECT ]		! !


!MaterialIdClause class publicMethods !

isAbstract
	^false!

root
	^Tool! !


!MaterialIdClause publicMethods !

adaptToClass: aToolClass
	id := aToolClass materialClass symbol
	! !


!SimpleBrowser class publicMethods !

isAbstract
	^false!

materialClass
	^Indexable!

toolName
	^'simple browser tool'! !


!SimpleBrowser publicMethods !

initialize

	super initialize.

	self initMainComponent: SimpleBrowserUp iPart: SimpleBrowserIp fPart: SimpleBrowserFp.

	self fPart createSubFps
!

material: aMaterial
	super material: aMaterial.
	self fPart indexable: aMaterial.! !


!SimpleBrowserFp publicMethods !

createSubFps

	super createSubFps.

	listerFp := ListerFp new.
	self addSubFp: listerFp.

	editorFp := SimpleEditorFp new.
	self addSubFp: editorFp.
!

editorFp
	^editorFp!

indexable
	^self listerFp indexable.!

indexable: anIndexable
	self editorFp editable: ( anIndexable at: 1 ).
	self listerFp indexable: anIndexable.
	self listerFp selectItemIndex: 1.
	!

initialize

	super initialize.
!

listerFp
	^listerFp!

switchItem: item

	self editorFp editable: item!

update: aSymbol from: anObject

	aSymbol == #cEvItemSelected ifTrue: [
		^self switchItem: ( self listerFp selectedItem ) ].

	super update: aSymbol from: anObject.! !


!SimpleBrowserIp class publicMethods !

fPartClass
	^SimpleBrowserFp! !


!SimpleBrowserUp class publicMethods !

iPartClass
	^SimpleBrowserIp! !


!SimpleBrowserUp publicMethods !

create

	form := ( self rootWidget )
		createForm: 'form'
		argBlock: [ :w | w
			width: 320;
			height: 240 ].

	self manage.!

createSubUpFor: anIPart

	| uPart |

	( anIPart isKindOf: ListerIp ) ifTrue: [
		uPart := ListerUp new: ( self form ) with: anIPart.
		uPart listWidget parent setValuesBlock: [ :w | w
			leftAttachment: XmATTACHFORM;
			topAttachment: XmATTACHFORM;
			bottomAttachment: XmATTACHFORM;
			rightAttachment: XmATTACHPOSITION;
			rightPosition: 33 ] ].

	( anIPart isKindOf: SimpleEditorIp ) ifTrue: [
		uPart := SimpleEditorUp new: ( self form ) with: anIPart.
		uPart textWidget parent setValuesBlock: [ :w | w
			leftAttachment: XmATTACHPOSITION;
			leftPosition: 33;
			topAttachment: XmATTACHFORM;
			bottomAttachment: XmATTACHFORM;
			rightAttachment: XmATTACHFORM ] ].
!

form
	^form!

manage
	self form manageChild.!

unmanage
	self form unmanageChild.!

update: aSymbol from: anIPart

	( aSymbol == #cEvTextChanged ) ifTrue: [
		^self updateText ].

	super update: aSymbol from: anIPart.
!

updateText! !


!SimpleEditor class publicMethods !

isAbstract
	^false!

materialClass
	^SimpleEditable!

toolName
	^'simple editor tool'! !


!SimpleEditor publicMethods !

initialize

	super initialize.

	self initMainComponent: SimpleEditorUp iPart: SimpleEditorIp fPart: SimpleEditorFp.
!

material: aMaterial
	self fPart editable: aMaterial! !


!SimpleEditorFp publicMethods !

editable
	^editable!

editable: anEditable
	editable := anEditable.
	self changed: #cEvEditableChanged!

initialize
!

text: aString
	self editable text: aString! !


!SimpleEditorIp class publicMethods !

fPartClass
	^SimpleEditorFp! !


!SimpleEditorIp publicMethods !

text
	^self fPart editable text!

text: aString
	self fPart text: aString
!

update: aSymbol from: anObject

	aSymbol == #cEvEditableChanged ifTrue: [
		^self changed: aSymbol ].

	super update: aSymbol from: anObject.!

updateEditable: anEditable
	self changed: #cEvEditableChanged.! !


!SimpleEditorUp class publicMethods !

iPartClass
	^SimpleEditorIp! !


!SimpleEditorUp publicMethods !

create

	textWidget := ( self rootWidget )
		createScrolledText: 'text'
		argBlock: [ :w | w
			editMode: XmMULTILINEEDIT;
			scrollHorizontal: false;
			wordWrap: true;
			width: 180;
			height: 240 ].

	textWidget addCallback: XmNlosingFocusCallback
		receiver: self
		selector: #losingFocus:clientData:callData:
		clientData: nil.

	self manage.!

losingFocus: widget clientData: clientData callData: callData
	self iPart text: ( self textWidget getString )!

manage
	self textWidget manageChild.!

textWidget
	^textWidget!

unmanage
	self textWidget unmanageChild.!

update: aSymbol from: anObject

	aSymbol == #cEvEditableChanged ifTrue: [
		^self updateText ].

	super update: aSymbol from: anObject.!

updateText
	self textWidget setString: ( self iPart text )! !


!SimpleViewer class publicMethods !

isAbstract
	^false!

materialClass
	^SimpleViewable!

toolName
	^'simple viewer tool'! !


!SimpleViewer publicMethods !

initialize

	super initialize.

	self initMainComponent: SimpleViewerUp iPart: SimpleEditorIp fPart: SimpleEditorFp.
! !


!SimpleViewerFp publicMethods !

initialize
!

text! !


!SimpleViewerIp class publicMethods !

fPartClass
	^SimpleViewerFp! !


!SimpleViewerIp publicMethods !

text
	^self fPart text!

update: aSymbol from: anObject

	aSymbol == #cEvTextChanged ifTrue: [
		^self changed: aSymbol ].

	super update: aSymbol from: anObject.! !


!SimpleViewerUp class publicMethods !

iPartClass
	^SimpleViewerIp! !


!SimpleViewerUp publicMethods !

create

	textWidget := ( self rootWidget )
		createScrolledText: 'text'
		argBlock: [ :w | w
			editMode: XmMULTILINEEDIT;
			scrollHorizontal: false;
			editable: false;
			width: 180;
			height: 240 ].
	self manage.!

manage
	self textWidget manageChild.!

textWidget
	^textWidget!

unmanage
	self textWidget unmanageChild.!

update: aSymbol from: anObject

	aSymbol == #cEvTextChanged ifTrue: [
		^self updateText ].

	super update: aSymbol from: anObject.!

updateText
	self labelWidget labelString: ( self iPart text )! !


!Tool class publicMethods !

materialClass
	^Material!

new
	^super new initialize.!

toolName
	^self printString! !


!Tool publicMethods !

fPart
	^fPart!

fPart: anFPart
	fPart := anFPart!

initialize

	self initUiClosure!

initMainComponent: anUPart iPart: anIPart fPart: anFPart

	self fPart: ( anFPart new ).
	self iPart: ( anIPart new: ( self fPart ) ).
	self uPart: ( anUPart new: ( self mainWidget ) with: ( self iPart ) ).
!

initUiClosure

	| shell main |

	shell := CwTopLevelShell
		createApplicationShell: 'shell'
		argBlock: [ :w |
			w title: ( self toolName ) ].
	shell addCallback: XmNwindowCloseCallback
		receiver: self
		selector: #windowClose:clientData:callData:
		clientData: nil.
	self shellWidget: shell.

	main := ( self shellWidget )
		createMainWindow: 'mainWindow'
		argBlock: nil.
	main manageChild.

	self mainWidget: main.
!

iPart
	^iPart!

iPart: anIPart
	iPart := anIPart!

mainWidget
	^mainWidget!

mainWidget: aWidget
	mainWidget := aWidget!

material
	^material
!

material: aMaterial
	material := aMaterial
!

realize
	self shellWidget realizeWidget.!

shellWidget
	^shellWidget!

shellWidget: aShell
	shellWidget := aShell!

toolName

	toolName ifNil: [
		^self class toolName ].

	^toolName.!

toolName: aString

	toolName := aString.
	self shellWidget title: aString.!

uPart
	^uPart!

uPart: anUPart
	uPart := anUPart!

windowClose: widget clientData: clientData callData: callData
	! !


!ToolnameClause class publicMethods !

isAbstract
	^false!

root
	^Tool! !


!ToolnameClause publicMethods !

adaptToClass: aToolClass
	name := aToolClass toolName! !


!UPart class publicMethods !

new: aWidget with: iPart
	^super new initialize: aWidget with: iPart! !


!UPart publicMethods !

create
	self subclassResponsibility!

createSubUpFor: anIPart
	self subclassResponsibility!

initialize
!

initialize: aWidget with: anIPart

	self initialize.

	rootWidget := aWidget.
	iPart := anIPart.
	anIPart addDependent: self.

	self create.!

iPart
	^iPart!

manage
	self subclassResponsibility!

rootWidget
	^rootWidget!

unmanage
	self subclassResponsibility!

update: aSymbol from: anIPart

	( aSymbol == #cEvSubIpAdded ) ifTrue: [
		^self createSubUpFor: ( anIPart subIp ) ].

	^super update: aSymbol from: anIPart.! !

